use std::{fs, path::PathBuf};

use clap::Parser;
use executor::{execute_all, Executors};

#[derive(Parser, Debug)]
pub struct Args {
    file: PathBuf,
    primary_executor: Executors,
}

fn main() {
    let args = dbg!(Args::parse());

    let f = fs::read_to_string(args.file).unwrap();
    let pl = rpl::from_ron(&f);

    execute_all(pl.0);
}
